/* Cdigo para el estudio de las transiciones pticas en centros
   de color en haluros alcalinos.
   Francisco Domnguez-Adame.                                         */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define TMAX       20.        /* Parmetro theta mximo               */
#define TMIN        5.        /* Parmetro theta mnimo               */
#define DT          0.2       /* Incremento del parmetro theta       */
#define EPS         0.001     /* Precisin en el mtodo de Newton     */
#define NMAX       30         /* Nmero mximo de iteraciones         */
#define E_0         0.1       /* Valor inicial para epsilon_0         */
#define E_1         1.6       /* Valor inicial para epsilon_1         */
#define FILENAME "DATOS.DAT"  /* Nombre del archivo                   */

double raiz_0(double t) {
   double ea=E_0,ed,f,df,error=1.;
   int i=0;
   while (error>EPS) {
       i++;
       if(i==NMAX) {
           puts("Demasiadas iteraciones en raiz_0\n");
           exit(1);
       }
       f=tan(ea)-sqrt(t*t-ea*ea)/ea;
       df=1./(cos(ea)*cos(ea))+(t/ea)*(t/ea)/sqrt(t*t-ea*ea);
       ed=ea-f/df;
       error=fabs(ed-ea);
       ea=ed;
   }
   return ed;
}

double raiz_1(double t) {
   double ea=E_1,ed,f,df,error=1.;
   int i=0;
   while (error>EPS) {
       i++;
       if(i==NMAX) {
           puts("Demasiadas iteraciones en raiz_0\n");
           exit(1);
       }
       f=-1./tan(ea)-sqrt(t*t-ea*ea)/ea;
       df=1./(sin(ea)*sin(ea))+(t/ea)*(t/ea)/sqrt(t*t-ea*ea);
       ed=ea-f/df;
       error=fabs(ed-ea);
       ea=ed;
   }
   return ed;
}

void main(void) {
   double e0,e1,theta,aux,paso=DT;
   FILE *out;
   out=fopen(FILENAME,"w");
   for (theta=TMIN;theta<=TMAX;theta+=paso) {
      e0=raiz_0(theta);
      e1=raiz_1(theta);
      aux=log10(e1*e1-e0*e0);
      fprintf(out,"%8.6lf   %8.6lf\n",log10(theta),aux);
   }
   fclose(out);
}
