/* Cdigo para el clculo de la densidad acumulada de modos
   en cadenas armnicas desordenadas.
   Francisco Domnguez-Adame.                                         */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#define N 1000          /* Nmero de tomos de la cadena              */
#define MA   1.0        /* Masa de los tomos A                       */
#define MB   2.0        /* Masa de los tomos B                       */
#define C    0.5        /* Concentracin de tomos B                  */
#define NP 100          /* Nmero de promedios                        */
#define NL 1000         /* Nmero de frecuencias                      */
#define LMIN 0.0        /* Frecuencia mnima                          */
#define LMAX 4.5        /* Frecuencia mxima                          */
#define FILENAME  "DATOS.DAT"  /* Nombre del archivo                  */
                        /* Generador de nmeros aleatorios en [0,1]   */
#define RAN() ((double)rand()/(double)(RAND_MAX))

double alfa[N+1];       /* Vector con las masas reducidas             */
double idos[NL+1];      /* Vector con la densidad acumulada de modos  */

void red (void){        /* Genera una cadena desordenada              */
    int i;
    for(i=1;i<=N;i++){
       if(RAN()>=C) alfa[i]=1.;
       else alfa[i]=MB/MA;
    }
}

void main(void) {
   int i,j,k;
   double ra,rd,dlambda=(double)(LMAX-LMIN)/NL;
   FILE *out;
   time_t t;  
   srand((unsigned)time(&t));
   out=fopen(FILENAME,"w");
   for(j=0;j<=NL;j++) idos[j]=0.;  /* Inicializa los vectores         */
   for(i=1;i<=NP;i++) {            /* Comienzan los promedios         */
      printf("%d   \r",i);
      red();
      for(j=1;j<=NL;j++) {
         ra=0.;
         for(k=1;k<=N;k++) {       /* Bucle sobre cada cadena         */
            rd=2.-alfa[k]*(LMIN+dlambda*(double)j)-ra;
            if(fabs(rd)<1e-50) {
               idos[j]+=1.;
               k++;
               ra=0.;
            } else {
               if(rd<0.) idos[j]+=1.;
               ra=1./rd;
            }
         }
      }
   }
   for(j=1;j<=NL;j++) {
      fprintf(out,"%8.6lf   ",LMIN+dlambda*(double)j);
      fprintf(out,"%8.6lf\n",idos[j]/(double)N/(double)NP);
   }
   fclose(out);
}
