/* Cdigo para calcular el coeficiente de transmisin de electrones
   en una  red finita de tomos  en una dimensin en  funcin de la
   longitud de la cadena, para una energa dada.
   Francisco Domnguez-Adame.                                         */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#define E       12.0                 /* Energa del electrn          */
#define N      100                   /* Nmero mximo de tomos       */
#define LAMBDA   1.0                 /* Constante de acoplamiento     */
#define L        1.0                 /* Distancia interatmica        */
#define FILENAME  "DATOS.DAT"        /* Archivo de datos              */

void main(void) {
    int i;
    double q,s,c,aux,r0,r1,r2,i0,i1,i2,tau;
    FILE *out;
    out=fopen(FILENAME,"w");
    q=sqrt(E);
    s=sin(q*L);              /* Variables auxiliares                  */
    c=cos(q*L);
    aux=2.*(c+LAMBDA*s/q);
    r0=1;                    /* Condiciones iniciales                 */
    i0=0;
    r1=0.5*aux;
    i1=s-LAMBDA*c/q;
    for(i=2;i<=N;i++) {
        r2=aux*r1-r0;
        i2=aux*i1-i0;
        r0=r1;
        i0=i1;
        r1=r2;
        i1=i2;
        tau=1./(r2*r2+i2*i2);
        fprintf(out,"%4d   %5.4lf\n",i,log(tau));
    }
    fclose(out);
}
