/* Cdigo para el estudio de caminantes aleatorios y clculo del
   desplazamiento cuadrtico medio.
   Francisco Domnguez-Adame                                          */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#define N        1000         /* Nmero de caminantes aleatorios      */
#define NS      10000         /* Nmero de saltos del caminante       */
#define TMAX      100         /* Tiempo mximo                        */
#define P           0.01      /* Probabilidad de salto                */
#define FILENAME "DATOS.DAT"  /* Nombre del archivo de datos          */

long int radio[NS];           /* Radio cuadrtico medio               */

void main(void) {
   long int i,n,pos;
   float paso,p,aux;
   time_t t;
   FILE *out;
   out=fopen(FILENAME,"w");
   srand((unsigned)time(&t));
   paso=(float)TMAX/NS;                /* Incremento de tiempo        */
   p=P*RAND_MAX;                       /* Probabilidad de salto       */
   for(n=0;n<NS;n++) radio[NS]=0;
   for(n=0;n<N;n++) {                  /* Bucle para los caminantes   */
      pos=0;                           /* Caminante en el origen      */
      for(i=0;i<NS;i++) {
         aux=rand();                   /* Elige un nmero aleatorio   */
         if(aux<p) pos++;              /* Salto a la derecha          */
         if(aux>p && aux<2*p) pos--;   /* Salto a la izquierda        */
         radio[i]+=pos*pos;            /* Calcula el radio cuadrtico */
      }                                /* en el instante t=i*paso     */
   }
   for(i=0;i<NS;i+=10)                 /* Imprime cada 10 pasos       */
          fprintf(out,"%8.6f   %8.6f\n",i*paso,(float)radio[i]/N);
   fclose(out);
}
