/* Cdigo para el clculo del espectro de absorcin de agregados
   moleculares debido a los excitones de Frenkel.
   Francisco Domnguez-Adame                                          */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define N        30    /* Nmero de molculas del sistema             */
#define J         1.0  /* Integral de transferencia                   */
#define G         0.01 /* Semianchura de la funcin Lorentziana       */
#define EMIN     -2.2  /* Energa mnima                              */
#define EMAX     -1.7  /* Energa mxima                              */
#define NE     2000    /* Nmero de pasos de energa del espectro     */
#define PI        3.141592654
#define FILENAME  "DATOS.DAT"

double e[N+1];         /* Almacena las energas propias               */
double d[N+1];         /* Almacena las constantes de acoplamiento     */

void vectores(void) {  /* Calcula las energas y las intensidades     */
   int i;
   double aux;
   for(i=1;i<=N;i++) {
      e[i]=-2.*J*cos(PI*(double)i/(N+1));
      if((i/2)*2==i) d[i]=0;
      else {
         aux=tan(0.5* PI*(double)i/(N+1));
         d[i]=(double)(2./(N+1))/aux/aux;
      }
   }
}

void main(void) {
   double energia,de=(EMAX-EMIN)/(double)NE,rho,g2=G*G;
   int i;
   FILE *out;
   out=fopen(FILENAME,"w");
   vectores();
   for(energia=EMIN;energia<=EMAX;energia+=de) {
      rho=0.;
      for(i=1;i<=N;i++) rho+=g2*d[i]/((energia-e[i])*(energia-e[i])+g2);
      fprintf(out,"%8.6lf   %8.6lf\n",energia,rho/(double)N);
   }
   fclose(out);
}
